<template>
  <v-dialog
    v-model="showing"
    @update:modelValue="updateShow"
    max-width="320"
    persistent
    transition="dialog-top-transition"
  >
    <authenticator />
  </v-dialog>
</template>

<script setup lang="ts">
import { ref, onMounted, watch } from 'vue'
import { Authenticator } from '@aws-amplify/ui-vue'
import { getCurrentUser, fetchUserAttributes, fetchAuthSession} from 'aws-amplify/auth'
import { Hub } from 'aws-amplify/utils'
import '@aws-amplify/ui-vue/styles.css'

const props = defineProps({
  show: { type: Boolean, required: true }
})

let showing = ref(props.show)

const updateShow = (value: boolean) => {
  showing.value = value
}

watch(
  () => props.show,
  (newValue: boolean) => {
    showing.value = newValue
  }
)

const emit = defineEmits(['onSignedIn', 'onSignedOut'])

onMounted(async () => {
  await loadUser()
})

const signedOut = () => {
  emit('onSignedOut')
}

Hub.listen('auth', async (data) => {
  switch (data.payload.event) {
    case 'signedIn':
      await loadUser()
      break

    case 'signedOut':
      signedOut()
      break
  }
})

const loadUser = async () => {
  try {
    const { accessToken, idToken } = (await fetchAuthSession()).tokens ?? {};
    const groups = accessToken?.payload["cognito:groups"]

    const userAttributes = await fetchUserAttributes()
    emit('onSignedIn', {
      ...userAttributes,
      groups
    })
  } catch (error) {
    // user is not logged in
    console.log('error', error)
    signedOut()
  }
}
</script>
